using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.UI;
using System.Linq;
using TMPro;
using UnityEngine.Events;
using System.Runtime.ExceptionServices;
using System.Security.Permissions;

namespace SamMod
{
    public class SamMod
    {
        public static void Main()
        {                   

//Steel Sword
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),                                                      
                    NameOverride = "Steel Sword UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Basic steel sword used for combat",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/1.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Steel Sword.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Iron Long Sword
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),                                                      
                    NameOverride = "Iron Long Sword UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Long swords need advanced skill",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/2.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Iron Long Sword.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Cricket Bat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Baseball Bat"),                                                      
                    NameOverride = "Cricket Bat UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Really Powerful Bat Better than Basic bat",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/3.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cricket Bat.png", 1f);
                        Instance.FixColliders();                                                                                                               
                                                                                       
                    }
                }
            );
            //Polished Baseball Bat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Baseball Bat"),                                                      
                    NameOverride = "Polished Baseball Bat UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Just a better bat baseball model",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/4.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Polished Baseball Bat.png", 1f);
                        Instance.FixColliders();                                                                                                               
                                                                                       
                    }
                }
            );
            //Worker Hammer
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Wrench"),                                                      
                    NameOverride = "Worker Hammer UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Can really repair but stil can be used for combat",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/5.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Worker Hammer.png", 1f);
                        Instance.FixColliders();                                                                                                               
                                                                                       
                    }
                }
            );
            //Throwing Knife
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Throwing Knife UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Very Hard to Aim",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/6.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Throwing Knife.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Katana
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),                                                      
                    NameOverride = "Katana UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Migty Katana For Special Fights",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/7.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Katana.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Worker Sledgehammer
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),                                                      
                    NameOverride = "Worker Sledgehammer UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Really Heavy Tool for everthing",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/8.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Worker Sledgehammer.png", 1f);
                        Instance.FixColliders();                                                                                                               
                                                                                       
                    }
                }
            );
            //Baton
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),                                                      
                    NameOverride = "Baton UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Police Using These",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/9.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Baton.png", 1f);
                        Instance.FixColliders();                                                                                                               
                                                                                       
                    }
                }
            );
            //Combat Knife 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Combat Knife UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Army Have These Knifes For Defense",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/10.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Combat Knife.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Dagger 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Dagger UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Dagger used to be a secret Weapon",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/11.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Dagger.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Push Dagger 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Push Dagger UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Deadly Brutal Weapon",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/12.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Push Dagger.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Hand Dagger 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Hand Dagger UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Very Old Type of Dagger",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/13.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Hand Dagger.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Greatsword
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),                                                      
                    NameOverride = "Greatsword UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "heavier sword for great fights",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/14.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Greatsword.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Gold Club
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),                                                      
                    NameOverride = "Golf Club UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Basic of all melee combat",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/15.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Golf Club.png", 1f);
                        Instance.FixColliders();                                                                                                               
                                                                                       
                    }
                }
            );
            //Steel Baseball Bat 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),                                                      
                    NameOverride = "Steel Baseball Bat UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Baseball Bat but steel that it",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/16.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Steel Baseball Bat.png", 1f);
                        Instance.FixColliders();
                                                                                                                                   
                                                                                       
                    }
                }
            );
            //Army Knife 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Army Knife UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "These are specialy for soilders",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/17.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Army Knife.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );                                                                                                                                                                                                                                                                                                                               
            //Hand Saw
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),                                                      
                    NameOverride = "Hand Saw UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Lets Get to Work",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/18.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Hand Saw.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Guitar 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),                                                      
                    NameOverride = "Guitar UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Play or Kill with guitar?",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/19.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Guitar.png", 1f);
                        Instance.FixColliders();                                                                                                               
                                                                                       
                    }
                }
            );
            //Bass Guitar 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),                                                      
                    NameOverride = "Bass Guitar UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Play or Kill with Bass guitar? well more bass much better",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/20.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Bass Guitar.png", 1f);
                        Instance.FixColliders();                                                                                                               
                                                                                       
                    }
                }
            );
            //Kukri Knife 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Kukri Knife UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Very weird shape",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/21.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Kukri Knife.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Worker Screwdriver 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Worker Screwdriver UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Little sharp maybe",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/22.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Worker Screwdriver.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Fork 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Fork UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Still Sharp",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/23.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Fork.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Kitchen Knife 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Kitchen Knife UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Kitchen need kitchen knife",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/24.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Kitchen Knife.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Silver Spear  
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Spear"),                                                      
                    NameOverride = "Silver Spear UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Seems like old style weapon",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/25.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Silver Spear.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Castle Spear  
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Lance"),                                                      
                    NameOverride = "Castle Spear UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Castle weapon for great knights",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/26.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Castle Spear.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
            //Legend Sword 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),                                                      
                    NameOverride = "Legend Sword UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "This Legendary sword is very expensive",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/27.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Legend Sword.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Boxing Glove 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),                                                      
                    NameOverride = "Boxing Glove UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Round 1 Fight!",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/28.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Boxing Glove.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 4f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;                                                                                                               
                                                                                       
                    }
                }
            );
            //Sport Boxing Glove 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),                                                      
                    NameOverride = "Sport Boxing Glove UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Round 2 Fight!",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/29.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sport Boxing Glove.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 4f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.2f;                                                                                                               
                                                                                       
                    }
                }
            );
            //Shuriken
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Shuriken UMP",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "Basic but works",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/30.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Shuriken.png");
                        foreach (var c in Instance.GetComponents<Collider2D>())
                        {
                            GameObject.Destroy(c);
                        }
                        Instance.AddComponent<BoxCollider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().colliders = Instance.GetComponentsInChildren<Collider2D>();
                        Instance.GetComponent<PhysicalBehaviour>().StabReleaseSpeedModifier = 0.75f;

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        var prop = ModAPI.FindPhysicalProperties("Metal");
                        prop.Sharp = true;
                        //prop.LodgeStrengthMultiplier = 3f;
                        prop.SharpAxes = new[]
                        {
                            new SharpAxis(Vector2.up, 0.0f, 0.0f, true, true),
                            new SharpAxis(Vector2.down, 0.0f, 0.0f, true, true),
                            new SharpAxis(Vector2.left, 0.0f, 0.0f, true, true),
                            new SharpAxis(Vector2.right, 0.0f, 0.0f, true, true),
                        };
                        phys.Properties = prop;
                    }
                }
            );
            //Hammer
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Wrench"),                                                      
                    NameOverride = "Hammer UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Can really repair but stil can be used for combat",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/31.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Hammer.png", 1f);
                        Instance.FixColliders();                                                                                                               
                                                                                       
                    }
                }
            );
            //Hatchet
ModAPI.Register(
      new Modification()
      {
          OriginalItem = ModAPI.FindSpawnable("Axe"),
          NameOverride = "Hatchet UMP",
          NameToOrderByOverride = "A",
          DescriptionOverride = "Standard weapon for any situation",
          CategoryOverride = ModAPI.FindCategory("Melee"),
          ThumbnailOverride = ModAPI.LoadSprite("Thumbs/32.png"),
          AfterSpawn = (Instance) =>
          {
              var axeHandle = Instance.transform.GetChild(0);
              axeHandle.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Hatchet Handle.png");
              var axeHead = axeHandle.GetChild(0);
              axeHead.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Hatchet Head.png");
              var properties = ModAPI.FindPhysicalProperties("Metal");
              properties.Sharp = true;
              properties.SharpAxes = new SharpAxis[]
              {
                  new SharpAxis(Vector2.right, 0f, 0.5f, true, false)
              };
              axeHead.gameObject.GetComponent<PhysicalBehaviour>().Properties = properties;
          }
      }
  );
  //Fireman Axe
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Axe"),
                    NameOverride = "Fireman Axe",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "For firemans and killers.",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/33.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        bool flipped = Instance.transform.localScale.x < 0f;
                        Instance.transform.localScale = new Vector2(1.3f * (flipped ? -1f : 1f), 1.3f)
                          ;
                        var axeHandle = Instance.transform.GetChild(0);
                        axeHandle.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Fireman Axe Handle.png", 1.2f);
                        var axeHead = axeHandle.GetChild(0);
                        axeHead.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Fireman Axe Head.png", 1.2f);
                        axeHead.localPosition = new Vector3(0.001f, 0.49f);
                        var properties = ModAPI.FindPhysicalProperties("Metal");
                        properties.Sharp = true;
                        properties.SharpAxes = new SharpAxis[]
                        {
                            new SharpAxis(Vector2.right, 0f, 0.25f, true, false)
                        };
                        axeHead.gameObject.GetComponent<PhysicalBehaviour>().Properties = properties;
                    }
                }
            );
  //Brawl Axe
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Axe"),
                    NameOverride = "Brawl Axe",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "Brawl!.",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/34.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        bool flipped = Instance.transform.localScale.x < 0f;
                        Instance.transform.localScale = new Vector2(1.3f * (flipped ? -1f : 1f), 1.3f)
                          ;
                        var axeHandle = Instance.transform.GetChild(0);
                        axeHandle.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Brawl Handle.png", 1.2f);
                        var axeHead = axeHandle.GetChild(0);
                        axeHead.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Brawl Head.png", 1.2f);
                        axeHead.localPosition = new Vector3(0.09f, 0.40f);
                        var properties = ModAPI.FindPhysicalProperties("Metal");
                        properties.Sharp = true;
                        properties.SharpAxes = new SharpAxis[]
                        {
                            new SharpAxis(Vector2.right, 0f, 0.25f, true, false)
                        };
                        axeHead.gameObject.GetComponent<PhysicalBehaviour>().Properties = properties;
                    }
                }
            );                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
//Screwdriver 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Screwdriver UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Little sharp maybe",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/35.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Screwdriver.png", 1f);                                                                                                               
                                                                                       
                    }
                }
            );
            //Sledgehammer
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),                                                      
                    NameOverride = "Sledgehammer UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Really Heavy Tool for everthing",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/36.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sledgehammer.png", 1f);
                        Instance.FixColliders();                                                                                                               
                                                                                       
                    }
                }
            );
            //Nail
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Nail UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Can be used as upgrade for any weapon",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/37.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Nail.png", 1f);
                        
                                                                                       
                    }
                }
            );
            //Tiny Spike
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Tiny Spike UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Build your own weapon!",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/38.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Tiny Spike.png", 1f);
                        
                                                                                       
                    }
                }
            );
            //Polished Stick
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),                                                      
                    NameOverride = "Polished Stick UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "try a training fight or build your own weapon!",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/39.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Polished Stick.png", 1f);
                        Instance.FixColliders();
                                                                                       
                    }
                }
            );
            //Brass Knuckles 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),                                                      
                    NameOverride = "Brass Knuckles UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "bandits have it",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/40.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Brass Knuckles.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 2f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;                                                                                                               
                                                                                       
                    }
                }
            );
            //Club 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Baseball Bat"),                                                      
                    NameOverride = "Club UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Cavemans like these",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/41.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Club.png", 1f);                                                                                                               
                        Instance.FixColliders();                                                               
                    }
                }
            );
            //Paladin Hammer
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),                                                      
                    NameOverride = "Paladin Hammer UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Heavy Weapon only for real paladins",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/42.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Paladin Hammer.png", 1f);
                        Instance.FixColliders();                                                                                                               
                                                                                       
                    }
                }
            );
            //Pan 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),                                                      
                    NameOverride = "Pan UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Lets cooking! or not?",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/43.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pan.png", 1f);                                                                                                               
                        Instance.FixColliders();                                                               
                    }
                }
            );
            //Pipe Wrench 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Wrench"),                                                      
                    NameOverride = "Pipe Wrench UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Can Reapair!",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/44.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pipe Wrench.png", 1f);                                                                                                               
                        Instance.FixColliders();                                                               
                    }
                }
            );
            //Scissors
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Scissors UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Eazy for use",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/45.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Scissors.png", 1f);
                        
                                                                                       
                    }
                }
            );
            //Garden Scissors
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Garden Scissors UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Make your own art of bash",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/46.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Garden Scissors.png", 1f);
                        
                                                                                       
                    }
                }
            );
            //Spike Mace
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),                                                      
                    NameOverride = "Spike Mace UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "its sharp!",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/47.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Spike Mace.png", 1f);
                        
                                                                                       
                    }
                }
            );
            //Mace
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),                                                      
                    NameOverride = "Mace UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Not Mace Windu",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/48.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Mace.png", 1f);
                        Instance.FixColliders();
                                                                                       
                    }
                }
            );
            //Rake
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),                                                      
                    NameOverride = "Rake UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "nobody likes leaves",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/49.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rake.png", 1f);
                        
                                                                                       
                    }
                }
            );
            //Dumbbell
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),                                                      
                    NameOverride = "Dumbbell UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Super Strong!!",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/50.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Dumbbell.png", 1f);
                        Instance.FixColliders();
                                                                                       
                    }
                }
            );
            //Pipe
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),                                                      
                    NameOverride = "Pipe UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Eazy to obtain",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/51.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pipe.png", 1f);
                        Instance.FixColliders();
                                                                                       
                    }
                }
            );
            //Pole Cue
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stick"),                                                      
                    NameOverride = "Pole Cue UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Lets Play Table pool",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/52.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pole Cue.png", 1f);
                        Instance.FixColliders();
                                                                                       
                    }
                }
            );
            //Kunai
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Kunai UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Ninja style",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/53.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Kunai.png", 1f);
                        
                                                                                       
                    }
                }
            );
            //Kunai
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Kunai UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Ninja style",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/53.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Kunai.png", 1f);
                        
                                                                                       
                    }
                }
            );
            //Sai
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Sai UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Just Chrome Sai",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/54.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Sai.png", 1f);
                        
                                                                                       
                    }
                }
            );
            //Naginata
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Spear"),                                                      
                    NameOverride = "Naginata UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "bigger than katana",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/55.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Naginata.png", 1f);
                        
                                                                                       
                    }
                }
            );
            //Ninja Sword
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),                                                      
                    NameOverride = "Ninja Sword UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Not katana but still usefull",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/56.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Ninja Sword.png", 1f);
                        
                                                                                       
                    }
                }
            );
            //Pirate Sword
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),                                                      
                    NameOverride = "Pirate Sword UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Harr harr Pirates are comming",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/57.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pirate Sword.png", 1f);
                        
                                                                                       
                    }
                }
            );
            //Black Hammer
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),                                                      
                    NameOverride = "Black Hammer UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Like for smashing meat and something like this",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/58.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Black Hammer.png", 1f);
                        Instance.FixColliders();
                        
                                                                                       
                    }
                }
            );
            //Crowbar
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),                                                      
                    NameOverride = "Crowbar UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Crowbar can open doors not here",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/59.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Crowbar.png", 1f);
                        Instance.FixColliders();
                        
                                                                                       
                    }
                }
            );
            //Microphone Stand
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),                                                      
                    NameOverride = "Microphone Stand UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Can be used as weapon",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/60.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Microphone Stand.png", 1f);
                        Instance.FixColliders();
                        
                                                                                       
                    }
                }
            );
            //Broken Bottle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Broken Bottle UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Little bit similar like in ppg but sharp",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/61.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Broken Bottle.png", 1f);
                        
                        
                                                                                       
                    }
                }
            );
            //Machete
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Machete UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Very basic",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/62.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Machete.png", 1f);
                        
                        
                                                                                       
                    }
                }
            );
            //Showel
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),                                                      
                    NameOverride = "Showel UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Can be used as weapon",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/63.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Showel.png", 1f);
                        Instance.FixColliders();
                        
                                                                                       
                    }
                }
            );
            //Battle Hammer
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),                                                      
                    NameOverride = "Battle Hammer UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "For killing not for word",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/64.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Battle Hammer.png", 1f);
                        Instance.FixColliders();
                        
                                                                                       
                    }
                }
            );
            //Billhook
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Billhook UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Original From French",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/65.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Billhook.png", 1f);
                        
                        
                                                                                       
                    }
                }
            );
            //Trench Knife
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Trench Knife UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Like from trench fights",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/66.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Trench Knife.png", 1f);
                        
                        
                                                                                       
                    }
                }
            );
            //Rapier
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"),                                                      
                    NameOverride = "Rapier UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Old style weapon for intense duel",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("ThumbS/67.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Rapier.png", 1f);
                        
                        
                                                                                       
                    }
                }
            );
            //Bayonet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),                                                      
                    NameOverride = "Bayonet UMP",                                  
                    NameToOrderByOverride = "A",                                 
                    DescriptionOverride = "Highly skilled combat knife",                      
                    CategoryOverride = ModAPI.FindCategory("Melee"),             
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/68.png"),     
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Bayonet.png", 1f);
                        
                        
                                                                                       
                    }
                }
            );
            //Cleaver
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Axe"),
                    NameOverride = "Cleaver",
                    NameToOrderByOverride = "A",
                    DescriptionOverride = "Very sharp weapon",
                    CategoryOverride = ModAPI.FindCategory("Melee"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbs/69.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        bool flipped = Instance.transform.localScale.x < 0f;
                        Instance.transform.localScale = new Vector2(1.3f * (flipped ? -1f : 1f), 1.3f)
                          ;
                        var axeHandle = Instance.transform.GetChild(0);
                        axeHandle.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cleaver Handle.png", 1.2f);
                        var axeHead = axeHandle.GetChild(0);
                        axeHead.gameObject.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Cleaver Head.png", 1.2f);
                        axeHead.localPosition = new Vector3(0.035f, 0.29f);
                        var properties = ModAPI.FindPhysicalProperties("Metal");
                        properties.Sharp = true;
                        properties.SharpAxes = new SharpAxis[]
                        {
                            new SharpAxis(Vector2.right, 0f, 0.25f, true, false)
                        };
                        axeHead.gameObject.GetComponent<PhysicalBehaviour>().Properties = properties;
                    }
                }
            );

        }
    }
}